/*************************************************************************/
/* GP1.C  This simple program shows how to use the monostables as a      */
/* simple A/D converter.  This program can also be used for calibration  */
/* purposes.                                                             */
/*                                                                       */
/* This program was written in Turbo C.  Some changes may be required    */
/* with other compilers.                                                 */
/* July 1994  - Gary Sutcliffe W9XT                                      */
/*************************************************************************/


#include <stdio.h>
#include <dos.h>
#define GPADR 0x201   /*Game port register address*/

/* use the proper mask for the the A/D channel you are using */
#define MMASK1 0x01   /* mask for monostable 1, pins 1 & 3*/
#define MMASK2 0x02   /* mask for monostable 2, pins 6 & 8*/
#define MMASK3 0x04   /* mask for monostable 3, pins 9 & 11*/
#define MMASK4 0x08   /* mask for monostable 4, pins 13 & 15*/



main()
{
int count;
delay(0);                      /* calibrate delay */

while(1)
	{
	count =0;              /* zero loop counter*/
	disable();      	/*turn off interrupts*/
	outportb(GPADR,0);      /*trigger one-shots*/
	while(inportb(GPADR) & MMASK1)count++; /*increment count until it times out*/
	enable();		/*turn interrupts back on*/
	printf(" %d\n",count);
	delay(500);             /*wait 1/2 second before doing it again */
	}
}   /* end GP1.C */
