	
	;OS8085C PROGRAM 1993
	;  BY SAM ULBING, N4UAU
	;This set of programs is offered as shareware and may 
	;be used for experimentation and development of experimental 
	;projects. if you plan to use these programs for prolonged periods or 
	;for commercial please contact the author. 
	;sam ulbing, 5305 nw 57th lane, gainesville, fl 32606.
	;any comments,corrections or improvements are invited.
	;enjoy ! 
	;-------------------------------------------
	;-------------------------------------------
	;AN 8085 OPERATING SYSTEM
	; WITH SUBROUTINES FOR VARIOUS TASKS INCLUDING 
	; -DOWNLOADING HEX FORMAT FILES
	; -EDIT RAM CONTENTS
	; -UPLOAD DATA FROM 8085 TO HOST
	; -EXECUTE STARTING AT A SPECIFIED PLACE IN MEMORY
	; -MOVE A BLOCK OF DATA FROM ONE LOCATION TO ANOTHER
	; -PROGRAMMING 27C64 EPROMS
	; -PROGRAM 87C51
	; -EXECUTE A NUMBERS GAME. EITHER FROM
	;    THE PC OR  STAND ALONE 
	;THE 8085 DETERMINES BAUD RATE FROM THE PC AND WILL 
	; RELIABLY TRANSFER DATA AT UP TO 4800 BAUD.ENTER A SPACE
	; AFTER RESETTING THE 8085 TO PERMIT IT TO DETERMINE 
	; BAUD RATE
	;-------------------------------------------
	;-------------------------------------------
	.equ    bitime,h'60fc
	.equ    hlfbit,h'60fe
	.EQU    NUMLITES,H'60FB ;LITES COUNTER
	.equ    bitso,h'0b
	.equ    bitsi,h'09
;===========================================
	;THIS IS RST VECTOR AREA
	.ORG    h'0000
	jmp     INIT
	;***RST 5.0
	.org    H'0028
	JMP     H'6028
	;***RST5.5 START BCD STANDALONE IF PRESS RST5.5 ON STARTUP
	.ORG    H'002C
	JMP    BCDRST
	;***RST6.5
	.ORG    H'0034  
	JMP     H'6034
	;***RST7.5
	.ORG    H'003C
	JMP     H'603C 
	;***RST'S VECTORED TO 60XX IN O/S       
;===============================================
	; INITIALIZES, CALLS BAUD RATE OR BRANCHES IF 
	;    AN RST BEFORE SPACE FOR SERIAL I/O
       .ORG     h'0050  ;INITIALIZE
INIT:   mvi     a,h'0030   ;SET PIA PORTS AS INPORTS
	out     h'60
	lxi     sp,h'60fA  ;SET STACK POINTER ADDRESS
	EI
	MVI     E,H'01  ; SHOWS A NEW BCDNUMS GAME
	MVI     A,H'0E  ;UNMASK ALL INTERRUPTS
	SIM
crt1:   mvi     a,h'c1
	sim                   ; set sod hi
	call    brid          ; SET baudrate
	LXI     H,MSG1     
	call    MSGOUT        ; BAUD msg
	ei                    ; SET INTERRUPTS
	jmp     INTRO
MSG1:   .db     h'0d,h'0a
	.db     " "
	.db     h'0d,h'0a
	.db     h'00
;=================================================
;INTRO
INTRO:  MVI     B,H'01
INTRO1: LXI     H,MSG9
	CALL    MSGOUT
	DCR     B
	JNZ     INTRO1
	JMP     MENU1
MSG9:   .DB     H'0D,H'0A
	.DB     H'0D,H'0A
	.DB     H'0D,H'0A
	.DB     H'0D,H'0A
	.DB     H'0D,H'0A
	.DB     "  AN 8085 MACHINE DESIGNED BY:",H'0D,H'0A
	.DB     "        N4UAU ",H'0D,H'0A
	.DB     "           SAM ULBING ",H'0D,H'0A
	.DB     "               IN 1992",H'0D,H'0A
	.DB     "This set of programs is offered as shareware and may " 
	.DB     "be used for experimentation and development of experimental " 
	.DB     "projects. if you plan to use these programs for prolonged periods or " 
	.DB     "for commercial please contact the author." 
	.DB     "sam ulbing, 5305 nw 57th lane, gainesville, fl 32606."
	.DB     "any comments,corrections or improvements are invited."
	.DB     "     os8085c-31may93",h'0d,h'0a
	.DB     "ENJOY !"
	.DB     H'0D,H'0A
	.DB     H'00
;============================================
;MENU   
	;PRINTS MENU GETS A LETTER AND
		; GOES TO SELECTED LOCATION
MENU:   LXI     H,MSG2   ; PRINT MENU
	CALL    MSGOUT
MENU1:  LXI     H,MSG2A ;ENTER HERE IF DON'T WANT MENU PRINTED
	CALL    MSGOUT  
	CALL    ASCIN
	MOV     A,C      ; CK WHICH LETTER
	CPI     H'4D     ; M=MENU ?
	JZ      MENU
	CPI     H'52     ; R=RUN ?
	JZ      RUN
	CPI     H'45    ; E=EDIT ?
	JZ      EDIT     
	CPI     H'44     ; D=DUMP ?
	JZ      DUMP
	CPI     H'49     ; I=INTRO DEMO
	JZ      INTRO
	CPI     H'4F     ; O=OBJ LOADER
	JZ      OBJL
	CPI     H'42     ; B=BLOCK MOVE
	JZ      BLKMOV
	CPI     H'53     ; S=SUPER LOAD
	JZ      SUPRLD 
	cpi     H'55    ; U=UPLOADER
	JZ      UPLDR 
	CPI     H'50    ;P=EPROM PROGRAMMER
	JZ      EP2764
	CPI     H'51    ;Q=8751 PROGRAMMER
	JZ      EP8751
	CPI     H'47    ;G=BCD GAME
	JZ      BCDNUM
	LXI     H,MSG3   ; ELSE WRONG LETTER
	CALL    MSGOUT
	JMP     MENU
MSG2:   .DB     "  MENU SELECTIONS ARE:", h'0d,h'0a
	.DB     "      I=INTRO PROGRAM",h'0d,h'0a
	.DB     "      M=MENU",H'0D,H'0A
	.DB     "      E=EDIT",h'0d,h'0a
	.DB     "      O=OBJECT LOADER",h'0d,h'0a
	.DB     "      P=2764 PROGRAMMER",h'0d,h'0a
	.DB     "      Q=8751 PROGRAMMER",h'0d,h'0a
	.DB     "      B=BLOCK MOVE",h'0d,h'0a
	.DB     "      U=UPLOADER",H'0D,H'0A
	.DB     "      D=DUMP REGS", h'0d,h'0a
	.DB     "      S=ASCII LOADER",h'0d,h'0a        
	.DB     "      G=BCDNUM GAME",H'0D,H'0A
	.DB     "      R=RUN PGM",h'0d,h'0a             
	.DB     H'00
MSG2A:  .db     h'0d,h'0a
	.DB     "  TYPE A LETTER FOR YOUR CHOICE NOW", H'0D,H'0A 
	.DB     "      OR TYPE M FOR THE MENU   "
	.db     h'0d,h'0a
	.db     h'00
MSG3:   .db     h'0d,h'0a
	.DB     H'0D,H'0A
	.db     " INVALID LETTER TRY AGAIN",H'0d,h'0a
	.db     h'00
;=============================================
; EDIT 
	; REQSTS ADDR TO EDIT   
	; DISPLAYS DATA THEN ASKS FOR CHANGE
	; CR IS NO CHANGE. MINUS BACK SPACES MEMORY ADDRESS
	; ESCAPE TO EXIT        
EDIT:   LXI     H,MSG6        ; REQUEST ADDR
	CALL    MSGOUT
	CALL    ADDIN        
	CALL    SPACE
EDIT2:  MOV     A,M     ;GET DATA BYTE
	CALL    HEXOUT  ;OUTPUT HEX BYTE
	CALL    SPACE   ;SPACE ON SCREEN
	CALL    ASCIN   ;LOOK FOR NEW DATA
	MOV     A,C
	CPI     H'0D    ;IF CR NO NEW DATA
	JZ      EDIT4
	CPI     H'2D    ;LOOK FOR MINUS SIGN
	JNZ     EDIT3
	CALL    ASCIN   ; GET NO TO GO BACK
	MOV     A,C
	CALL    ATOB
EDIT1:  DCX     H       ;DCR ADDR PTR
	DCR     A
	JNZ     EDIT1
	JMP     EDIT5
EDIT3:  CALL    ATOB    ;CONVERT 1ST NIBBLE
	RLC
	RLC
	RLC
	RLC
	MOV     D,A    ;STORE PART RESULT
	CALL    ASCIN  ; 2ND BYTE OF DATA
	MOV     A,C
	CALL    ATOB   ;CONVERT LO NIBBLE
	ORA     D      ;SUM WITH HI ONE
	MOV     M,A    ;STORE IN MEMORY
EDIT4:  INX     H      ;NEXT ADDRESS
EDIT5:  CALL    CRLF   ;NEW LINE
	CALL    ADDOUT ;OUTPUT ADDRESS
	CALL    SPACE
	JMP     EDIT2
MSG6:  .db     h'0d,h'0a
	.db     " EDIT STARTING AT WHAT  ADDRESS ?"
	.db     h'0d,h'0a
	.db     h'00  
;================================================
;OBJECT LOADER      
	;LOADS AN OBJ FILE
	; IN INTEL HEX FORMAT
	;YOU SPECIFY OFFSET FROM COMPILE LOCATION IN K
	; BYTES FOR ACTUAL LOADING ADDRESS='ORG' ADDRESS+OFFSET.  
	; calls hexinn so no echo
OBJL:   LXI     H,OBJMSG0       ;OFFSET LOAD/COMPILE IN K
	CALL    MSGOUT
	CALL    ASCIN
	MOV     A,C
	CPI     H'0D    ;CR= NO OFFSET
	JZ      OBJL1A
	CALL    ATOB
	RLC
	RLC
	RLC
	RLC
	MOV     E,A
	JMP     OBJL1B
OBJL1A: MVI     B,H'00
OBJL1B: LXI     H,OBJMSG1       ;SEND FILE NOW
	CALL    MSGOUT
OBJL1:  MVI     A,H'4E  ; NO ECHO DESIRED
	CALL    ASCIN   ;COLON IGNORED
	CALL    HEXINn   ;NUMBER BYTES
	MOV     D,A
	CALL    HEXINn   ;HI BYTE ADDRSS
	ADD     E       ;ADD OFFSET TO ADDRESS
	MOV     H,A
	CALL    HEXINn   ;LO ADDRS BYTE
	MOV     L,A
	CALL    HEXINn   ;FILE TYPE
	CPI     H'01  ;01 IS LAST ONE
	JZ      OBJL3
OBJL2:  CALL    HEXINn   ;DATA BYTE
	MOV     M,A
	INX     H
	DCR     D
	JNZ     OBJL2 
	CALL    HEXINn   ;CK DIGIT IGNORED
	CALL    HEXINn   ;IGNORE H'0D0A
	JMP     OBJL1
OBJL3:  CALL    HEXINn   ;CK DIGIT IGNORED
	CALL    HEXINn  ;H'0D0A IGNORED
	LXI     H,OBJMSG2
	CALL    MSGOUT
	JMP     MENU1
OBJMSG0: .DB     H'0D,H'0A
	.DB     " WHAT COMPILE/LOAD OFFSET IN K BYTES ",H'0D,H'0A
	.DB     H'00
OBJMSG1: .DB     H'0D,H'0A
	.DB     "SEND FILE NOW. DO NOT TOUCH "
	.DB     "KEYBOARD UNTIL FILE LOADED"
	.DB     H'0D,H'0A
	.DB     H'00
OBJMSG2: .DB    H'0D,H'0A
	.DB     "    FILE IS NOW LOADED"
	.DB     H'0D,H'0A
	.DB     H'00
;=============================================
;2764 PROGRAMMER
	;THIS PROGRAM PROGRAMS 27C64 EPROMS
;******** IS PROGRAM IN RAM?
EP2764: LXI     H,MSG19 
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=PRGM IS IN RAM
	JNZ     MENU
;****MAKE SURE POWER ON AND CHIP NOT IN SOCKET
	LXI     H,MSG20 ;
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=EPROM NOT IN
	JNZ     MENU
;*****GET VERIFICATION BEFORE TURN ON POWER
	LXI     H,MSG20
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=EPROM NOT IN
	JNZ     MENU
;******SET ALL PORTS AS OUTPUTS
	MVI     A,H'0F
	OUT     H'60
;SET ALL DATA ADDRESS PORTS LOW
	MVI     A,H'00
	OUT     H'61
	OUT     H'63
	OUT     H'80
;******TURN POWER ON BOARD OFF          
	MVI     A,H'03 
	OUT     H'62
;******REQUEST PUT EPROM IN SOCKET
	LXI     H,MSG21   
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=EPROM IN SOCKET
	JNZ     MENU
;******ASK VERIFICATION IN SOCKET
	LXI     H,MSG21
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=EPROM IN SOCKET
	JNZ     MENU
;*****PUT 5 VOLTS TO VCC & VPP
	MVI     A,H'7F
	OUT     H'62
	MVI     B,H'FF
EP10:   DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP10
;*****VERIFY CHIP IS BLANK
	MVI     A,H'7B  ; SET CE LOW
	OUT     H'62
	MVI     D,H'FF  ;DATA IS A BLANK BYTE
	MVI     C,H'00  ;FLAG FOR BLANK CHECKING
	CALL    READIT
	MOV     A,B     ;CHECK FLAG FOR AN ERROR
	CPI     H'00
	JZ      EP11    ;CHIP IS BLANK
	LXI     H,MSG27 ;CHIP NOT BLANK
	CALL    MSGOUT
	JMP     EP997   ;DESELECT AND DE POWER
EP11:   LXI     H,MSG25 ;EPROM IS BLANK
	CALL    MSGOUT
;******ARE YOU SURE YOU WANT TO PROGRAM EPROM
EP12:   LXI     H,MSG26
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=PROGRAM
	JNZ     EP997   ;DESELECT & DEPOWER
;******ASK VERIFICATION
	LXI     H,MSG26 
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=PROGRAM
	JNZ     EP997   ;DESELECT & DEPOWER
;****HERE GOES WITH PROGRAMMING
	MVI     A,H'FF  ;PORT 1=OUTPUT
	OUT     H'60
;*****RAISE VCC TO 6.25
	MVI     A,H'7A  
	OUT     H'62
	MVI     B,H'FF
EP10A:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP10A
;******RAISE VPP TO 12.75
	MVI     A,H'78  
	OUT     H'62
	MVI     B,H'FF
EP10B:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP10B
	LXI     H,H'2000 ;START ADDRESS FOR RAM
;******PROGRAM A DATA BYTE
EP13:   MOV     A,H     
	MVI     B,H'19  ;DECIMAL 25 FOR PGM COUNT
	OUT     H'63    ;HI ADDRS IN PORT 3
	MOV     A,L     
	OUT     H'80    ;LOW ADDRSS ON LATCH
EP15:   MOV     A,M     ;GET DATA FROM RAM
	MOV     D,A     ;HOLD FOR COMPARE LATER
	OUT     H'61    ;DATA IN PORT 1
	MVI     A,H'70  ;PROGRAM PULSE GOES LOW 
	OUT     H'62
	MVI     C,H'22  ;HOLD FOR 100 MICROSEC
EP30:   DCR     C
	JNZ     EP30    ;DELAY LOOP
	MVI     A,H'78  ;PROGRAMM PULSE GOES HI 
	OUT     H'62
	DCR     B
;*****VERIFY THE BYTE
	MVI     A,H'FE  ;PORT 1=INPUT   
	OUT     H'60
	MVI     A,H'68  ;OE GOES LOW TO READ
	OUT     H'62    
	IN      H'61    ;READ DATA
	MOV     E,A     ;STORE TEMPORAIRLY
	MVI     A,H'78  ;OE GOES HI
	OUT     H'62    
	MVI     A,H'FF  ;PORT 1=OUTPUT
	OUT     H'60
	MOV     A,E     
	CMP     D       ;COMPARE RAM & ROM DATA
	JZ      EP40    ;BYTE GOOD GO TO NEXT BYTE
EP35:   MOV     A,B
	CPI     H'00
	JNZ     EP15    ;TRY AGAIN TO PROGRAM
EP900:  LXI     H,MSG22 ;EPROM HAS FAILED
	CALL    MSGOUT
	JMP     EP995
EP40:   INX     H       ;
	MOV     A,H     ;HAVE WE FINISHED 
	CPI     H'40    
	JNZ     EP13    ;NO
;*****THRU PROGRAMMING
;*****DROP VPP
EP950:  MVI     A,H'7A
	OUT     H'62
	MVI     B,H'FF
EP956:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP956
;*****DROP VCC
	MVI     A,H'7B  
	OUT     H'62
	MVI     B,H'FF
EP956A: DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP956A
;*****VERIFY WHOLE CHIP
EP957:  LXI     H,H'2000
	MOV     D,M     ;PUT 1ST RAM BYTE IN D
	MVI     C,H'01  ;FLAG FOR RAM COMPARE
	CALL    READIT
	MOV     A,B     ;CHECK FAIL FLAG
	CPI     H'00
	JZ      EP958   ;CHIP PASSES
	LXI     H,MSG27 ;CHIP FAILS
	CALL    MSGOUT
	JMP     EP997   ;DESELECT AND DE POWER
EP958:  LXI     H,MSG23 ;CHIP PASSES MSG
	CALL    MSGOUT
	JMP     EP997
;*****TURN OFF EPROM HARDWARE
EP995:  MVI     A,H'7A  ;DROP VPP
	OUT     H'62
	MVI     B,H'FF
EP996:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP996
	MVI     A,H'7B  ;DROP VCC
	OUT     H'62
	MVI     B,H'FF
EP996A: DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     EP996A
EP997:  MVI     A,H'7F  ;SET CE HIGH
	OUT     H'62
;*****SET ALL DATA ADDRESS PORTS LOW
	MVI     A,H'00
	OUT     H'61
	OUT     H'63
	OUT     H'80
	MVI     A,H'03  ;DEPOWER CHIP
	OUT     H'62
	LXI     H,MSG24 ;ALL DONE REMOVE CHIP
	CALL    MSGOUT
	JMP     MENU
;******ROUTINE TO READ A CHIP
READIT: LXI     H,H'2000;START ADDRESS
	MVI     A,H'FE  ;SET PORT 1 AS INPUT    
	OUT     H'60
EP80:   MOV     A,H     
	OUT     H'63    ;HI ADDRS IN PORT 3
	MOV     A,L     
	OUT     H'80    ;LOW ADDRSS ON LATCH
	MVI     A,H'6B  ;OE LOW FOR READ
	OUT     H'62    
	IN      H'61    ;READ DATA
	MOV     E,A     ;STORE TEMPORAIRLY
	MVI     A,H'7B  ;OE HI 
	OUT     H'62    
	MOV     A,E     ;COMPARE 
	CMP     D       ;
	JZ      EP85    ;DATA BYTE OK
	MVI     B,H'01  ;BAD DATA FLAG
	RET
EP85:   INX     H       ;GET NEXT DATA BYTE
	MOV     A,H
	CPI     H'40
	RZ              ;DONE CHECKING
;*****ARE WE CHECKING FOR BLANKS OR COMPARING RAM
	MOV     A,C
	CPI     H'00            
	JZ      EP80    ;CK FOR BLANKS
	MOV     A,M     ;VERIFY SO GET NEXT RAM BYTE
	MOV     D,A
	JMP     EP80
	;******END OF READ ROUTINE
;EP8751--THIS LOADS CODE FROM H'2000 TO H'2FFF TO 
;       AN 8751 USING QUICK PULSE.
;       THE SUBROUTINE TO LOAD IT CAN BE STORED IN 
;       RAM AT 3000 SO DOES NOT NEED TO GO IN ROM

;EP8751A--THIS LOADS CODE FROM H'2000 TO H'2FFF TO 
;       AN 8751 USING QUICK PULSE.
;       HAS SECURITY BIT LOCK SEQUENCE
;       THE SUBROUTINE TO LOAD IT CAN BE STORED IN 
;       RAM AT 3000 SO DOES NOT NEED TO GO IN ROM
;; THIS PROGRAM PROGRAMS 87C51
	
;******** IS PROGRAM IN RAM?
EP8751: LXI     H,MSG19A
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=PRGM IS IN RAM
	JNZ     MENU
;****MAKE SURE POWER ON AND CHIP NOT IN SOCKET
	LXI     H,MSG20 ;
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=EPROM NOT IN
	JNZ     MENU
;*****GET VERIFICATION BEFORE TURN ON POWER
	LXI     H,MSG20
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=EPROM NOT IN
	JNZ     MENU
;******SET ALL PORTS AS OUTPUTS
	MVI     A,H'0F
	OUT     H'60
;SET ALL DATA ADDRESS PORTS LOW
	MVI     A,H'00
	OUT     H'61
	OUT     H'63
	OUT     H'80
;******TURN POWER ON BOARD OFF          
	MVI     A,H'83  
	OUT     H'62
;******REQUEST PUT EPROM IN SOCKET
	LXI     H,MSG21   
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=EPROM IN SOCKET
	JNZ     MENU
;******ASK VERIFICATION IN SOCKET
	LXI     H,MSG21
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=EPROM IN SOCKET
	JNZ     MENU
;***** TO PROGRAM THE DATA
;***** PUT 5 VOLTS TO VCC,VPP,P3.6,P3.7,P2.7
;***** AND 0 VOLTS TO P2.6
	MVI     A,H'DE
	OUT     H'62
	MVI     B,H'FF
MP10:   DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP10    
;*****VERIFY CHIP IS BLANK
MP10A:  MVI     D,H'FF  ;DATA IS A BLANK BYTE
	MVI     C,H'00  ;FLAG FOR BLANK CHECKING
	CALL    REEDIT
	MOV     A,B     ;CHECK FLAG FOR AN ERROR
	CPI     H'00
	JZ      MP11    ;CHIP IS BLANK
	LXI     H,MSG27 ;CHIP NOT BLANK
	CALL    MSGOUT
	JMP     MP996   ;SEE IF WANT A SECURITY CK
MP11:   LXI     H,MSG25 ;EPROM IS BLANK
	CALL    MSGOUT
;******ARE YOU SURE YOU WANT TO PROGRAM EPROM
MP12:   LXI     H,MSG26
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=PROGRAM
	JNZ     MP997   ;DESELECT & DEPOWER
;******ASK VERIFICATION
	LXI     H,MSG26 
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=PROGRAM
	JNZ     MP997   ;DESELECT & DEPOWER
;****HERE GOES WITH PROGRAMMING
	MVI     A,H'FF  ;PORT 1=OUTPUT
	OUT     H'60
	LXI     H,H'2000 ;START ADDRESS FOR RAM
;******PROGRAM A DATA BYTE
MP13:   MOV     A,H     
	MVI     B,H'19  ;DECIMAL 25 FOR PGM COUNT
	OUT     H'63    ;HI ADDRS IN PORT 3
	MOV     A,L     
	OUT     H'80    ;LOW ADDRSS ON LATCH
MP15:   MOV     A,M     ;GET DATA FROM RAM
	MOV     D,A     ;HOLD FOR COMPARE LATER
	OUT     H'61    ;DATA IN PORT 1
;******RAISE VPP TO 12.75
	MVI     A,H'DC
	OUT     H'62
	PUSH    B
	MVI     B,H'FF  ;**********1.2 MSEC
MP10B:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP10B
	POP     B
MP20:   MVI     A,H'D4  ;PROGRAM PULSE GOES LOW 
	OUT     H'62
	MVI     C,H'15  ; 21 DECIMAL HOLD FOR 100 MICROSEC
MP30:   DCR     C
	JNZ     MP30    ;DELAY LOOP
	MVI     A,H'DC  ;PROGRAM PULSE GOES HI 
	OUT     H'62
	DCR     B
MP35:   MOV     A,B
	CPI     H'00
	NOP     ;DELAY
	NOP
	NOP
	JNZ     MP20    ;DO THIS 25 TIMES WITH
			; A 16 U SEC DELAY
;*****DROP VPP
MP950:  MVI     A,H'DE
	OUT     H'62
	PUSH    B
	MVI     B,H'FF  ;*******1.2 MSEC 
MP956:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP956
	POP     B
MP40:   INX     H       ;
	MOV     A,H     ;HAVE WE FINISHED 
	CPI     H'30    ;FOR 8751 HAVE ONLY 4K BYTES TO PROGRAM
	JNZ     MP13    ;NO
;***** THRU PROGRAMMING THE DATA

;***** VERIFY WHOLE CHIP
MP957:  LXI     H,H'2000
	MOV     D,M     ;PUT 1ST RAM BYTE IN D
	MVI     C,H'01  ;FLAG FOR RAM COMPARE
	CALL    REEDIT
	MOV     A,B     ;CHECK FAIL FLAG
	CPI     H'00
	JZ      MP958   ;CHIP PASSES
	LXI     H,MSG27 ;CHIP FAILS
	CALL    MSGOUT
	JMP     MP997   ;DESELECT AND DE POWER
;******CHIP PASSES DO YOU WANT TO PROGRAM SECURITY BITS
MP958:  LXI     H,MSG23 ;CHIP PASSES MSG
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=PROGRAM
	JNZ     MP997   ;DESELECT & DEPOWER
;******ASK VERIFICATION
	LXI     H,MSG23
	CALL    MSGOUT
	CALL    ESCIN   
	MOV     A,C
	CPI     H'59    ;Y=PROGRAM
	JNZ     MP997   ;DESELECT & DEPOWER

;****HERE GOES WITH PROGRAMMING SECURITY BIT 1
;*****PUT 5 VOLTS TO VCC,VPP,P3.6,P3.7,P2.7,P2.6
	MVI     A,H'FE
	OUT     H'62
	MVI     B,H'FF
MP110:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP110   
;******RAISE VPP TO 12.75
	MVI     A,H'FC
	OUT     H'62
	MVI     B,H'FF  ;**********1.2 MSEC
MP110B: DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP110B
	MVI     B,H'19  ;DECIMAL 25 FOR PGM COUNT
MP120:  MVI     A,H'F4  ;PROGRAM PULSE GOES LOW 
	OUT     H'62
	MVI     C,H'15  ; 21 DECIMAL HOLD FOR 100 MICROSEC
MP130:  DCR     C
	JNZ     MP130   ;DELAY LOOP
	MVI     A,H'FC  ;PROGRAM PULSE GOES HI 
	OUT     H'62
	NOP     ;DELAY
	NOP
	NOP
	DCR     B
	MOV     A,B
	CPI     H'00
	JNZ     MP120   ;DO THIS 25 TIMES WITH
			; A 16 U SEC DELAY
;*****DROP VPP
	MVI     A,H'FE
	OUT     H'62
	MVI     B,H'FF  ;*******1.2 MSEC 
MP1956: DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP1956
;****HERE GOES WITH PROGRAMMING SECURITY BIT 2
;*****PUT 5 VOLTS TO VCC,VPP,P2.7,P2.6
;***** 0 VOLTS FOR P3.6,P3.7
	MVI     A,H'EA
	OUT     H'62
	MVI     B,H'FF
MP210:  DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP210   
;******RAISE VPP TO 12.75
	MVI     A,H'E8
	OUT     H'62
	MVI     B,H'FF  ;**********1.2 MSEC
MP210B: DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP210B
	MVI     B,H'19  ;DECIMAL 25 FOR PGM COUNT
MP220:  MVI     A,H'E0  ;PROGRAM PULSE GOES LOW 
	OUT     H'62
	MVI     C,H'15  ; 21 DECIMAL HOLD FOR 100 MICROSEC
MP230:  DCR     C
	JNZ     MP230   ;DELAY LOOP
	MVI     A,H'E8  ;PROGRAM PULSE GOES HI 
	OUT     H'62
	NOP     ;DELAY
	NOP
	NOP
	DCR     B
	MOV     A,B
	CPI     H'00
	JNZ     MP220   ;DO THIS 25 TIMES WITH
			; A 16 U SEC DELAY
;*****DROP VPP
	MVI     A,H'EA
	OUT     H'62
	MVI     B,H'FF  ;*******1.2 MSEC 
MP2956: DCR     B       ;DELAY TO LET VOLTAGE SETTLE
	JNZ     MP2956
;***** VERIFY IT CANT BE READ
MP1957: LXI     H,H'2000
	MOV     D,M     ;PUT 1ST RAM BYTE IN D
	MVI     C,H'01  ;FLAG FOR RAM COMPARE
	CALL    REEDIT
	MOV     A,B     ;CHECK FAIL FLAG
	CPI     H'00    ;IF B=0 CHIP CAN BE READ
	JNZ     MP1958  ;CHIP READ PROTECTED    
	LXI     H,MSG28 ;CHIP NOT READ PROTECTED
	CALL    MSGOUT
	JMP     MP996   ;DESELECT AND DE POWER  
MP1958: LXI     H,MSG29 ;CHIP PROTECTED
	CALL    MSGOUT
;***** WANT A SECURITY CHECK?
MP996:  LXI     H,MSG30 
	CALL    MSGOUT
	CALL    ESCIN
	MOV     A,C
	CPI     H'59    ;Y=PRGM IS IN RAM
	JNZ     MP997
	CALL    SECCK
;*******TURN OFF EPROM HARDWARE
MP997:  ;SET ALL DATA ADDRESS PORTS LOW
	MVI     A,H'00
	OUT     H'61
	OUT     H'63
	OUT     H'80
	MVI     A,H'83  ;DEPOWER CHIP
	OUT     H'62
	MVI     A,H'F0
	OUT     H'60
	LXI     H,MSG24 ;ALL DONE REMOVE CHIP
	CALL    MSGOUT
	JMP     MENU
	;******END OF PROGRAM
MSG19:  .DB     H'0D,H'0A
	.DB     "    IS PROGRAM FOR 27C64 IN RAM?"
	.DB     H'0D,H'0A
	.DB     h'00
MSG19A: .DB     H'0D,H'0A
	.DB     "    IS PROGRAM FOR 87C51 IN RAM?"
	.DB     H'0D,H'0A
	.DB     h'00
MSG20:  .DB     H'0D,H'0A
	.DB     "  VERIFY POWER ON & EPROM NOT SOCKETED"
	.DB     H'0D,H'0A
	.DB     h'00
MSG21:  .DB     H'0D,H'0A
	.DB     "   INSERT EPROM IF LITE NOT RED"
	.DB     H'0D,H'0A
	.DB     h'00
MSG22:  .DB     H'0D,H'0A
	.DB     "   ATTEMPT TO PROGRAM HAS FAILED"
	.DB     H'0D,H'0A
	.DB     h'00
MSG23:  .DB     H'0D,H'0A
	.DB     "   EPROM IS PROGRAMMED"
	.DB     H'0D,H'0A
	.DB     "   DO U WANT TO PROGRAM SECURITY BITS?"
	.DB     H'0D,H'0A
	.DB     H'00
MSG24:  .DB     H'0D,H'0A
	.DB     "   REMOVE CHIP"
	.DB     H'0D,H'0A
	.DB     h'00
MSG25:  .DB     H'0D,H'0A
	.DB     "  EPROM IS BLANK"
	.DB     H'0D,H'0A
	.DB     h'00
MSG26:  .DB     H'0D,H'0A
	.DB     " ARE U SURE U WANT TO PROGRAM EPROM?"
	.DB     H'0D,H'0A
	.DB     h'00
MSG27:  .DB     H'0D,H'0A
	.DB     " EPROM FAILS"
	.DB     H'0D,H'0A
	.DB     h'00
MSG28:  .DB     H'0D,H'0A
	.DB     " !!!!! DANGER !!!!!- CHIP NOT READ PROTECTED"
	.DB     H'0D,H'0A
	.DB     h'00
MSG29:  .DB     H'0D,H'0A
	.DB     " CHIP IS READ PROTECTED NOW"
	.DB     H'0D,H'0A
	.DB     h'00
MSG30:  .DB     H'0D,H'0A
	.DB     " WANT TO READ CHIP CONTENTS?"
	.DB     H'0D,H'0A
	.DB     h'00

;******ROUTINE TO READ A CHIP
REEDIT: LXI     H,H'2000        ;START ADDRESS
	MVI     A,H'FE  ;SET PORT 1 AS INPUT    
	OUT     H'60
;***OUTPUT ADDRSS BYTE
MP80:   MOV     A,H     ;
	OUT     H'63    ;HI ADDRS IN PORT 3
	MOV     A,L     ;
	OUT     H'80    ;LOW ADDRSS PUT ON LATCH
	MVI     A,H'9E  ;SET P2.7 LOW FOR READ
	OUT     H'62    
	NOP     ;DELAY 11 MICRO SECONDS
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	IN      H'61    ;READ DATA
	MOV     E,A     ;STORE TEMPORAIRLY
	MVI     A,H'DE  ;SET P2.7 HI AGAIN
	OUT     H'62    
	MOV     A,E     ;NOW COMPARE 
	CMP     D       ;
	JZ      MP85    ;DATA BYTE OK
	MVI     B,H'01  ;BAD DATA FLAG
	RET
;*****GO TO NEXT DATA BYTE
MP85:   INX     H
	MOV     A,H
	CPI     H'30
	MVI     B,H'00  ;CHIP OK FLAG
	RZ      ;DONE CHECKING
;*****ARE WE CHECKING FOR BLANKS OR COMPARING RAM
	MOV     A,C
	CPI     H'00            
	JZ      MP80            ; BLANK CK
	MOV     A,M             ;VERIFY SO GET NEXT RAM BYTE
	MOV     D,A
	JMP     MP80
	;******END OF READ ROUTINE
;******ROUTINE TO READ CHIP CONTENTS TO MEMORY
SECCK:  LXI     H,H'2000
SECCK1: MVI     M,H'01  ;ERASE RAM
	INX     H
	MOV     A,H
	CPI     H'30
	JNZ     SECCK1  ;FILL WHOLE AREA
;***** MOVE EPROM DATA TO RAM
	LXI     H,H'2000        ;START ADDRESS
	MVI     A,H'FE  ;SET PORT 1 AS INPUT    
	OUT     H'60
;***OUTPUT ADDRSS BYTE
SECCK2: MOV     A,H     ;
	OUT     H'63    ;HI ADDRS IN PORT 3
	MOV     A,L     ;
	OUT     H'80    ;LOW ADDRSS PUT ON LATCH
	MVI     A,H'9E  ;SET P2.7 LOW FOR READ
	OUT     H'62    
	NOP     ;DELAY 11 MICRO SECONDS
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	IN      H'61    ;READ DATA
	MOV     M,A     ;STORE IN RAM
	MVI     A,H'DE  ;SET P2.7 HI AGAIN
	OUT     H'62    
;*****GO TO NEXT DATA BYTE
	INX     H
	MOV     A,H
	CPI     H'30
	MVI     B,H'00  ;CHIP OK FLAG
	RZ      ;DONE CHECKING
	JMP     SECCK2
;******END OFSECCK ROUTINE

;******THIS IS ASCIN WITHOUT ANY ESCAPE CAPABILITY
;****** NEEDED TO FORCE RETURNS TO MENU ONLY AFTER
;******  DEPOWERING THE EPROM
ESCIN:  DI
	push    d
	push    h
	NOP
	MOV     D,A     ;STORE NO ECHO FLAG
	EIN:    mvi     b,bitsi
EI1:    rim
	ora     a
	jm      EI1
	lhld    hlfbit
EI2:    dcr     l
	jnz     EI2
	dcr     h
	jnz     EI2
EI3:    lhld    bitime
EI4:    dcr     l
	jnz     EI4
	dcr     h
	jnz     EI4
	rim
	ral
	dcr     b
	jz      EI5
	mov     a,c
	rar
	mov     c,a
	jmp     EI3
EI5:    mov     a,c
	ani     h'7f
	CALL    COUT
EI7:    NOP
	POP     H
	POP     D
	EI
	RET
;===============================================
;BLOCK MOVE
	; MOVES A BLOCK OF DATA FROM ONE MEMORY
	;     LOCATION TO ANOTHER
	;INPUT START AND END ADDRESS FOR DATA TO BE MOVED
	;     AND START ADDRESS OF WHERE TO MOVE TO
BLKMOV: LXI     H,MSG10
	CALL    MSGOUT
	CALL    ADDIN
	PUSH    H       ;OLD START ADR
	LXI     H,MSG11
	CALL    MSGOUT
	CALL    ADDIN
	PUSH    H       ;OLD END ADDR
	LXI     H,MSG12
	CALL    MSGOUT
	CALL    ADDIN
	PUSH    H       ;NEW START ADDR
	POP     D       ;NEW START
	POP     B       ;OLD END
	POP     H       ;OLD START
MOVE3:  MOV     A,M
	INX     H
	STAX    D
	INX     D
	MOV     A,B
	CMP     H       ;HI BYTE END ADDR AND CURRENT
	JNZ     MOVE3
	MOV     A,C
	CMP     L
	JNZ     MOVE3
	LXI     H,MSG13
	CALL    MSGOUT  
	jmp     MENU1
MSG10:  .DB     H'0D,H'0A
	.DB     "BLOCK MOVE OLD BEGIN ADDR ?"
	.DB     H'00
MSG11:  .DB     H'0D,H'0A
	.DB     "OLD END ADDR ?"
	.DB     H'00
MSG12:  .DB     H'0D,H'0A
	.DB     "NEW START ADDR ?"
	.DB     H'00
MSG13:  .DB     H'0D,H'0A,"   DATA HAS BEEN MOVED"
	.DB     H'0D,H'0A,H'00
;==========================================
;UPLOADER PGM
	;GETS MEMORY ADDRESS AND 
	; SENDS GROUPS OF CHRS TO PC
UPLDR:  LXI     H,MSG6          ;START ADDRS
	CALL    MSGOUT
	CALL    ADDIN
	PUSH    H       ;SAVE START ADDRS
	LXI     H,MSG18
	CALL    MSGOUT          ;END ADDRS
	CALL    ADDIN
	XCHG            ;PUT END ADDR IN D&E
	POP     H
	call    crlf
UPL00:  MVI     B,H'10
UPL0:   MOV     A,H     ;OUTPUT ADDRS
	CALL    HEXOUT
	MOV     A,L
	CALL    HEXOUT
	CALL    SPACE
UPL1:   MOV     A,M     ;OUTPUT MEM DATA
	CALL    HEXOUT
	inx     H
	MOV     A,D     ;HI END ADDRS
	CMP     H
	JNZ     UPL3    ;HI BYTES NOT MATCH
	MOV     A,E     ;REST HI ADDRS
	CMP     L
	JNZ     UPL3    ;LO BYTES NOT MATCH
	CALL    CRLF
	JMP     MENU1
UPL3:   DCr     B
	JNZ     UPL1    ;DATA OUTPUT ON SAME ROW
	CALL    CRLF    ;START NEW ROW
	JMP     UPL00
MSG18:  .DB     H'0D,H'0A
	.DB     "END ADDRESS?"  
	.DB    H'0D,H'0A
	.DB     H'00
;======================================
;DUMP REG ROUTINE       
	;DUMPS REGISTERS THE ORDER IS
	; REG A,THE FLAG REGISTER IN BITS,REG B,C,D,E,H,L
 DUMP:  PUSH    H
	PUSH    D
	PUSH    B
	PUSH    PSW
	LXI     H,MSG7
	CALL    MSGOUT
	MVI     B,H'04
 REG2:  POP     D
	CALL    REG
	DCR     B
	JNZ     REG2
	CALL    CRLF
	CALL    CRLF
	JMP     MENU1
 REG:   MOV     A,D
	CALL    HEXOUT  
	CALL    SPACE
	CALL    SPACE
	MOV     A,B
	CPI     H'04
	JZ      BINA
	MOV     A,E
	CALL    hexout          
	CALL    SPACE
	CALL    SPACE
	RET
BINA:   MVI     L,H'09
	MOV     A,E
AGIAN:  DCR     L
	JZ      FIN1
	ORA     A
	JP      OHS
	MVI     C,H'31
	PUSH    PSW
	CALL    COUT
	POP     PSW
	RLC
	JMP     AGIAN
OHS:    MVI     C,H'30
	PUSH    PSW
	CALL     COUT
	POP     PSW
	RLC
	JMP     AGIAN
FIN1:   CALL    SPACE
	CALL    SPACE
FIN:    RET
MSG7:   .db     h'0d,h'0a
	.db     "REGISTER CONTENTS ARE:"
	.db     h'0d,h'0a
	.DB     "A---SZ-A-P-C--B---C---D---E---H---L-"
	.DB     H'0D,H'0A
	.db     h'00
;=============================================
;SUPER LOADER   
	;THIS PROGRAM WILL LOAD 256 BYTES OF
	;        ASCII CODE AND STORE IT 
	;GOOD FOR CHECKING FILES FOR NON PRINTABLE CHARS
	;SET ADDRESS TO LOAD DATA AND PROGRAM ADDRESS OK?
SUPRLD: LXI     H,MSG6A
	CALL    MSGOUT
	CALL    ADDIN
	PUSH    H
	CALL    SPACE   
	LXI     H,OBJMSG1
	CALL    MSGOUT
	POP     H
	MVI     D,H'FF
NEXT:   MVI     A,H'4E  ;NO ECHO
	CALL    ASCIN
	MOV     M,C
	INX     H
	DCR     D
	JNZ     NEXT
	LXI     H,OBJMSG2
	CALL    MSGOUT
	JMP     MENU1
MSG6A:  .DB     H'0D,H'0A
	.DB     "   LOAD STARTING AT WHAT ADDRESS?"
	.DB     H'00
;================================================
;RUN PROGRAM
	; GOES TO SPECIFIED ADDRESS AND 
	; RUNS THE PROGRAM       
RUN:    LXI     H,MSG4        ;REQUEST ADDR
	CALL    MSGOUT
	CALL    ADDIN         
	PCHL
MSG4:   .db     h'0d,h'0a
	.db     "   WHAT IS ADDRESS OF PGM TO RUN ?"
	.db     h'0d,h'0a
	.db     h'00
;=====================================================

;====================================================
	; DETERMINES BAUD RATE
	; WAITS FOR HI THEN FOLLOWED BY A LOW
	;       AS THE START CHARACTER
	; NEED TO SEND SPACE BAR
	;     FOR 1ST CHAR TO GET BAUD RATE  
BRID:   rim     ;**** BRID *****     
	ora     a   
	jp      brid                            
bri1:   rim
	ora     a
	jm      bri1    ;LOW IS START CHAR
	di
	lxi     h,-6
bri3:   mvi     e,h'04
bri4:   dcr     e
	jnz     bri4
	inx     h
	rim
	ora     a
	jp      bri3
	push    h
	inr     h
	inr     l
	shld    bitime
	pop     h
	ora     a
	mov     a,h
	rar
	mov     h,a
	mov     a,l
	rar
	mov     l,a
	inr     h
	inr     l
	shld    hlfbit
	ret
;===============================================
	; PUTS OUT A CHARACTER
	; FOR SERIAL I/O
COUT:   di      
	push    b        
	push    h       
	mvi     b,bitso
	xra     a
co1:    MVI     a,h'80
	rar
	sim
	lhld    bitime
co2:    dcr     l
	jnz     co2
	dcr     h
	jnz     co2
	stc
	mov     a,c
	rar
	mov     c,a
	dcr     b
	jnz     co1
	pop     h
	pop     b
	ei
	ret
;===================================================
	;GETS BINARY ADDR IN H & L. CONVERTS TO ASCII 
	;        AND OUTPUTS IT
ADDOUT: PUSH    B
	PUSH    h
	MOV     A,H
	CALL    HEXOUT
	MOV     A,L
	CALL    HEXOUT
	pop     H
	pop     B
	RET
;==================================================
	;PRINTS THE MESSAGE AT ADDRESS POINTED TO 
	;    BY H AND L
MSGOUT: mov     c,m
	xra     a
	ora     c
	rz              ;ALWAY USE
	call    cout    ; USE DELIMITER
	inx     h       ; 00 AT END OF
	jmp     MSGOUT  ; MESSAGE

;==================================================
	;  GETS 1 ASCII BYTE FROM SERIAL I/O
	; CALL WITH H'4E IN REG A IF NO ECHO WANTED
	; RETURNS BYTE IN REG C
ASCIN:  DI
	push    d
	push    h
	MOV     D,A     ;STORE NO ECHO FLAG
	CIN:    mvi     b,bitsi
ci1:    rim
	ora     a
	jm      ci1
	lhld    hlfbit
ci2:    dcr     l
	jnz     ci2
	dcr     h
	jnz     ci2
ci3:    lhld    bitime
ci4:    dcr     l
	jnz     ci4
	dcr     h
	jnz     ci4
	rim
	ral
	dcr     b
	jz      ci5
	mov     a,c
	rar
	mov     c,a
	jmp     ci3
ci5:    mov     a,c
	ani     h'7f
	mov     c,a 
	cpi     h'1b    ;ESCAPE RETURNS TO MENU
	JZ      CI6
	mov     a,d
	cpi     h'4e    ;4E IS NO ECHO FLAG
	jz      ci7
	CALL    COUT
CI7:    POP     H
	POP     D
	EI
	RET
CI6:    LXI     SP,H'60FB
	ei        
	JMP     MENU1
;===================================================
	; BRINGS A HEX BYTE IN FROM 2 ASCII 
	; BYTES IN SERIAL I/O
	; CALL WITH H'4E IN REG A IF NO ECHO WANTED      
	; RETURNS A NUMBER IN REG  A
	;entry at hexinn causes no echo
HEXINN: MVI     a,h'4e
HEXIN:  DI
	PUSH    B
	PUSH    D
	PUSH    H
	MOV     D,A
	PUSH    D       ; SAVE NO ECHO FLAG     
	CALL    ASCIN
	MOV     A,C
	CALL    ATOB
	RLC
	RLC
	RLC
	RLC
	MOV     H,A
	POP     D       ;GET NO ECHO FLAG
	MOV     A,D
	CALL    ASCIN
	MOV     A,C
	CALL    ATOB
	ORA     H
	POP     H
	POP     D
	POP     B
	EI
	RET
;=================================================
	;GETS 4 BYTE ADDRESS FROM CONSOLE AND ECHOS IT
	; NOTHING SENT TO IT
	; ADDRESS RETURNED IN H AND L
ADDIN:  PUSH    B
	PUSH    D
	MVI     A,H'00  ;WANT ECHO
	CALL    HEXIN
	MOV     H,A     ;1ST BYTE
	CALL    HEXIN
	MOV     L,A     ;2ND BYTE
	POP     D
	POP     B
	RET     
;================================================
	; CONVERTS ONE ASCII BYTE TO A HEX NIBBLE
ATOB:   SUI     H'30
	CPI     H'0A  ; IF < 10 DONE
	RC
	SUI     H'07  ; > 10 ONLY
	RET
;=================================================
	;CONVERTS A HEX NIBBLE TO AN ASCII BYTE
BTOA:   ANI     H'0F
	CPI     H'0A
	JC      BTOA1
	ADI     H'07
BTOA1:  ADI     H'30
	RET
;===============================================
	; END CARRIGE RETURN & LINE FEED
CRLF:   MVI     C,H'0D  ;CR
	CALL    COUT
	MVI     C,H'0A  ;LINE FEED
	CALL    COUT
CRLF1:  RET
;==============================================
       ;A SPACE FOR THE SCREEN
 SPACE: MVI     C,H'20
	CALL    COUT
	RET
;=========================================
	;PUTS OUT HEX NUMBER
	; NUMBER IS IN REG A
HEXOUT: PUSH    B
	PUSH    H
	MOV     B,A     ;SAVE FOR 2ND BYTE
	RRC
	RRC
	RRC
	RRC
	CALL    BTOA
	MOV     C,A             ;SO CAN OUTPUT IT
	CALL    COUT
	MOV     A,B     ;DO 2ND BYTE
	CALL    BTOA
	MOV     C,A
	CALL    COUT
	POP     H
	POP     B
	RET

;***BCD NUMS GAME
;this has been cut out of os8085c to make room for 8751 programmer
	;***OBJECT TO BE ONE TO REDUCE NUMBER TO ZERO
	;***HUMAN SETS START NUMBER FROM 1 TO 63
	;***CAN MOVE 1,2,3,OR 4 AT A MOVE
	;***FIRST NUMBER ENTERED AS BINARY NUMBER (USE LOWEST 6 DIPS)
	;***PLAY IS LINEAR SWITCH NUMBER NO BINARY
	;***RST 5.5 IS USED FOR BCDNUM GAME
BCDRST: DI      ;FOR STANDALONE PLAY
	INX     SP      ;NEEDED TO RESET SP CUZ 
	INX     SP      ;  NO RETURN USED
	JMP     LAD10
BCDNUM: MVI     C,H'00  ;INIT/PLAY FLAG
			;0=INIT,1=PLAYING
LAD00:  ;***A PAUSE HERE MACHINE TOO FAST FOR HUMAN 
	;***EI BEFORE THE BUTTON UP AGAIN AND WILL 
	MVI     D,H'02
	CALL    PAUSE
	MVI     A,H'43  ;PORT 61=OUT
			;PORT 62 BITS 0-5 IN BITS 6&7 OUT
	OUT     H'60    ;THIS SETS 62 AS OUTPUT FOR LITE
			;FLASHING TO SHOW HUMAN'S TURN
	EI
	MVI     A,H'0E  ;UNMASK RST 5.5
	SIM
LAD0:   MVI     A,H'80
	OUT     H'62    ;FLASH STATUS LITE ON
	MVI     D,H'01
	CALL    PAUSE
	MVI     A,H'60
	OUT     H'62    ;FLASH LITE OFF
	MVI     D,H'01
	CALL    PAUSE
	MVI     E,H'00  ;FLAG FOR INITIALIZE
	JMP     LAD0    ;GO UNTIL AN NTERRUPT
	;***PLAYER PUSHES BUTTON FOR INTR=5.5
	;***********************************
	;***SVC ROUTINE RST 5.5 FOR MAKING A MOVE
LAD10:  DI
	DCR     E
	JZ      BCDNUM  ;E=1 FOR START NEW GAME
	MVI     A,H'41  ;SET PORT 2 AS IN PORT
	OUT     H'60
	MOV     A,C     ;TO CK INIT/PLAY FLAG
	CPI     H'00    ;0=INITIAL,1=PLAYING
	JNZ     LAD100
	;***INITIALIZE GAME LITES
	MVI     D,H'02
	;***TO ALLOW TIME BEFORE RETURN TO MENU
	CALL    PAUSE
	IN      H'62    ;GET NUMBER LITES TO SET
	CMA             ;SO OFF ON SWITCH IS 0
	ANI     H'3F    ;MASK NON INPUT DATA
	JZ      MENU1   ;CAN'T HAVE 0 LITES
	CPI     H'3F    ;MAX NUMBER 63
	JC      LAD22
	JZ      LAD22
	JMP     BCDNUM  ;NUMBER>63
LAD22:  LXI     H,NUMLITES
	MOV     M,A     ;STORE NUMBER OF LITES
	CALL    CALCDISP;DISPLAY LITES
	JMP     LAD389  ;MACHINES TURN
	;***PLAYING THE GAME
LAD100: IN      H'62
	CMA             ;SO OFF ON SWITCH IS 0
	ANI     H'0F    ;ONLY LOOK AT LOW 4 BITS
	CPI     H'01
	JNZ     LAD101
	MOV     B,A     ;STORE 1 
	JMP     LAD121
LAD101:CPI      H'02
	JNZ     LAD102
	MOV     B,A     ;STORE 2
	JMP     LAD121
LAD102:CPI      H'04    ;REMEMBER USE LINEAR NOT
			;BINARY INPUT
	JNZ     LAD103
	MVI     B,H'03  ;STORE 3
	JMP     LAD121
LAD103: CPI     H'08
	JNZ     LAD999  ;NUMBER>4 OR 0
	MVI     B,H'04
LAD121:LXI      H,NUMLITES      ;GET REMAINING LITES
	MOV     A,M
	SUB     B
	MOV     M,A     ; SAVE NEW NUMBER OF LITES ON
LAD122: CALL    CALCDISP        ;DISPLAY RESULTS HUMANS MOVE
	;***PAUSE HERE BEFORE DECIDE IF HUMAN WINS
LAD389: MVI     D,H'02
	CALL PAUSE
	LXI     H,NUMLITES      ;GET REMAINING LITES
	MOV     A,M
	CPI     H'00
	JC      HUMAN   ;<0 HUMAN WINS
	JZ      HUMAN   ;=0 HUMAN WINS
	;***ELSE GAME CONTINUES
	;***MACHINES TURN
	CALL    MACHMOV         ;GET MACHINES MOVE
	LXI     H,NUMLITES      ;GET OLD NUM LITES
	MOV     A,M
	SUB     B       ;SUBTRACT MOVE
	MOV     M,A     ;SAVE NEW NUMBER OF LITES
	MVI     D,H'01
	;***PAUSE WHILE MACHINE PONDERS
	CALL    PAUSE
LAD200: CALL    CALCDISP        ;DISPLAY RESULTS MACHINES MOVE
	;***PAUSE HERE BEFORE DECIDE IF WON
	MVI     D,H'01
	CALL    PAUSE
	LXI     H,NUMLITES      ;GET OLD NUM LITES
	MOV     A,M
	CPI     H'00
	JC      MACHINE ;<0 MACHINE WINS
	JZ      MACHINE ;=0 MACHINE WINS
	;***ELSE GAME CONTINUES
LAD999: MVI     C,H'FF  ;SET INIT/PLAY FLAG
	JMP     LAD00   
	;***CALC MACHINES MOVE
MACHMOV:LXI     H,NUMLITES      ;GET REMAINING LITES
	MOV     A,M
	CPI     H'05
	JC      LASTMM
	ORA     A       ;SET ACCUM=0
	MVI     C,H'00  ;CLEAR C REG
	;***DIVIDE BY FOUR KEEP CARRY
	RAR
	MOV     B,A
	MOV     A,C
	RAR             ;FIRST CARRY IN C
	MOV     C,A
	MOV     A,B
	RAR
	MOV     B,A
	MOV     A,C
	RAR             ;SECOND CARRY INTO C
	RRC             ;MOVE CARRIED DIGITS TO THE RIGHT
	RRC
	RRC
	RRC
	RRC
	RRC
	CPI     H'01
	JC      LAD140  ;REMAINDER MUST BE >1 OR 
	JZ      LAD140  ;MUST ADD FOUR
	;***CARRY  AND ZERO BOTH 0 SO A>1
LAD135: DCR     A       ;THIS IS MACHINES CHOICE
LASTMM: MOV     B,A
	JMP     LAD141
LAD140: ADI     H'04    ;A= OR < 1 SO MUST
			;ADD FOUR AND THEN
			;CALC MACHINE MOVES
	JMP     LAD135
LAD141: RET
	;***************************************
	;***CALCULATE NUMBER OF LITES AND DISPLAY
	;***CALCDISP FOR BCD DISPLAY
CALCDISP:XRA    A       ;SET FLAGS TO ZERO
	LXI     H,NUMLITES      ;GET NUM OF LITES
	MOV     A,M
	ORA     A       ;RESET FLAGS
	MVI     C,H'00
CALC1:  SUI     H'0A    ;CONVERT TO BCD BY SUBTRACTING 10
	JC      DONE    ;UNTIL NUM < 10
	INR     C       
	JMP     CALC1
DONE:   ADI     H'0A
	MOV     B,A
	MOV     A,C
	RLC
	RLC
	RLC
	RLC
	ORA     B
	OUT     H'61
	RET
	;*****************************************      
	;***HUMAN WINS
	;***FLASH FIVES
HUMAN:  MVI     A,H'55
	OUT     H'61    ;FLASH LITE ON
	MVI     D,H'01
	CALL    PAUSE
	MVI     A,H'00
	OUT     H'61
	MVI     D,H'01
	CALL    PAUSE
	EI
	MVI     E,H'01  ;FLAG TO START NEW GAME
	JMP     HUMAN   ;WAIT FOR RST FOR NEW GAME
	;***************************************
	;********MACHINE WINS
	;FLASH EIGHTS
MACHINE:MVI     A,H'88
	OUT     H'61
	MVI     D,H'01
	CALL    PAUSE
	MVI     A,H'00
	OUT     H'61
	MVI     D,H'01
	CALL    PAUSE
	EI
	MVI     E,H'01  ;FLAG TO START NEW GAME
	JMP     MACHINE;WAIT FOR AN RST FOR NEW GAME
	;****************************************
	;***TO INSERT A PAUSE
PAUSE:  LXI     H,H'FFFF
PAUSE1: DCX     H
	MOV     A,H
	CPI     H'00
	JNZ     PAUSE1
	DCR     D
	JNZ     PAUSE
	RET

