/*
 * Some standard paths and constants used in the server. Make sure directory
 * names end with a '/'! All customizations should be in this file.
 */

#ifdef INSTALL

/*
 * Directory where the database hash tables can be found.
 */
#define DB_DIR "/gnu/ham_stuff/"

/*
 * The name of the file text version of the database.
 */
#define DB_TEXT "/gnu/ham_stuff/callsign.sort"

/*
 * Directory where the help files are.
 */
#define HELP_DIR "/gnu/ham_stuff/help/"

/*
 * Name of the primary help file.
 */
#define HELP_FILE "/gnu/ham_stuff/help/help"

/*
 * Prefix for all the secondary help files.
 */
#define HELP_PREFIX "/gnu/ham_stuff/help/help."

/*
 * Name of the info file.
 */
#define INFO_FILE "/gnu/ham_stuff/help/info_file"

#else	/* we're not installing */

#define DB_DIR "/u0/staff/bowen/callbook/database/"
#define DB_TEXT "/u0/staff/bowen/callbook/database/callsign.sort"

#define HELP_DIR "/u0/staff/bowen/callbook/help/"
#define HELP_FILE "/u0/staff/bowen/callbook/help/help"
#define HELP_PREFIX "/u0/staff/bowen/callbook/help/help."

#define INFO_FILE "/u0/staff/bowen/callbook/help/info_file"

#endif	/* INSTALL */

/*
 * Year the database was created. This is used to find the correct year
 * in the different fields of each record and must be changed each time
 * a new database is installed. If anyone has a better way *PLEASE* let
 * me know.
 */

#define DB_YEAR 1990
