#include <stdio.h>
#include <fcntl.h>

#define PROBSIZE 512
#define ASCIIS	 256
#define FILENAME "callsign.sort"

main()
{
	int lcnt = ASCIIS;
	int prob[PROBSIZE], level[ASCIIS], shift[ASCIIS];
	unsigned int pattern[ASCIIS];
	int file, size, temp, min1, min2, maxshift=0;
	char buf[BUFSIZ];

	for (temp=0; temp<PROBSIZE; temp++)
		prob[temp] = 0;

	for (temp=0; temp<ASCIIS; temp++) {
		pattern[temp] = 0;
		shift[temp] = 0;
		level[temp] = temp;
	}

	if ((file = open(FILENAME, O_RDONLY)) == -1) {
		perror("open");
		exit(1);
	}

	while ((size = read(file, buf, BUFSIZ)) != 0)

		for (temp=0; temp<size; temp++)
			prob[buf[temp]]++;

	close(file);

	for (temp=0; temp<ASCIIS; temp++)

		if (prob[temp] == 0)
			level[temp] = 0;

	while (getmins(prob, &min1, &min2)) {

		prob[lcnt] = prob[min1] + prob[min2];
		prob[min1] = prob[min2] = 0;

		for (temp=0; temp<ASCIIS; temp++) {

			if (level[temp] == min1) {
				level[temp] = lcnt;
				pattern[temp] = (pattern[temp]>>1) | 0x80000000;
				shift[temp]++;
			}

			if (level[temp] == min2) {
				level[temp] = lcnt;
				pattern[temp] = (pattern[temp] >> 1);
				shift[temp]++;
			}
		}

		lcnt++;
	}

	printf("/*\n");
	printf(" * These tables are the static Huffman patterns used in\n");
	printf(" * Huffman compression routines. The patterns array is an\n");
	printf(" * array of all the bit patterns that occur to represent\n");
	printf(" * each character. It's indexed by ASCII code. The psize\n");
	printf(" * array is the number of significant bits in each pattern\n");
	printf(" * starting with the most significant from high to low.\n");
	printf(" */\n\n\n");

	for (temp=0; temp<ASCIIS; temp++)
		if (shift[temp] > maxshift)
			maxshift = shift[temp];

	printf("#define MAXSHIFT %d\n\n", maxshift);

	printf("struct qsearch {\n");
	printf("\tint shift;\n");
	printf("\tchar data;\n\n");
	printf("} quick[] = {\n");

	for (temp=0; temp<ASCIIS; temp++) {
		int temp2, flag;

		for (flag=1, temp2=0; temp2<ASCIIS && flag; temp2++)

			if (shift[temp2] < 9 && (pattern[temp2]>>24) == temp) {

				printf("\t{%d, '\\%03o'}%c\n", shift[temp2],
					temp2, (temp==ASCIIS-1 ? ' ' : ','));
				flag--;
			}

		if (flag)
			printf("\t{0, '\\000'}%c\n", (temp==ASCIIS-1?' ':','));
	}

	printf("};\n\n\n");

	printf("int psizes[] = {\n");

	for (temp=0; temp<16; temp++) {
		int temp2;

		printf("\t");

		for (temp2=0; temp2<16; temp2++)

			printf("%2d%c ", shift[temp*16+temp2],
					(temp*16+temp2==ASCIIS-1 ? ' ' : ','));

		printf("\n");
	}

	printf("};\n");
}


getmins(probs, min1, min2)
int *probs, *min1, *min2;
{
	int temp;

	*min1 = -1;
	*min2 = -1;

	for (temp=0; temp<PROBSIZE; temp++)

		if (probs[temp])

			if (*min1 == -1)
				*min1 = temp;

			else if (probs[*min1] > probs[temp])
				*min1 = temp;

	for (temp=0; temp<PROBSIZE; temp++)

		if (probs[temp] && temp != *min1)

			if (*min2 == -1)
				*min2 = temp;

			else if (probs[*min2] > probs[temp])
				*min2 = temp;

	if (*min2 != -1)
		return 1;
	else
		return 0;
}
